## ffindex 0.9.3

=== debian/changelog ===
ffindex (0.9.3-1) unstable; urgency=low

  * Initial release (Closes: #661111)

 -- Laszlo Kajan <lkajan@rostlab.org>  Fri, 24 Feb 2012 10:38:57 +0100

=== debian/rules ===
#!/usr/bin/make -f

# Uncomment this to turn on verbose mode.
export DH_VERBOSE=1

%:
	dh $@ --parallel

FFMANPAGES = ffindex_build.1 ffindex_get.1 ffindex_modify.1
BINNAMES =	ffindex_build="build file index from files in directories";\
		ffindex_get="retrieve entries from file index";\
		ffindex_modify="modify file index entries";\

.PHONY: override_dh_installman
override_dh_installman: $(FFMANPAGES)
	dh_installman

$(FFMANPAGES): %.1 : debian/tmp/usr/bin/%
	unset LD_PRELOAD && export LD_LIBRARY_PATH=debian/tmp/usr/lib && eval '$(BINNAMES)' && help2man --no-info --no-discard-stderr '--help-option= ' -n "$$$*" --version-option="-v" '$<' -o '$@'

.PHONY: override_dh_clean
override_dh_clean:
	rm -f $(FFMANPAGES)
	dh_clean

.PHONY: override_dh_strip
override_dh_strip:
	dh_strip --dbg-package=ffindex-dbg

get-orig-source:
	mkdir -p ../tarballs
	uscan --verbose --force-download --destdir=../tarballs

## ffindex 0.9.6.1

=== Makefile ===
OS:= $(shell uname)

ifeq ($(OS), Darwin)
MFILE=Makefile.osx
else
MFILE=Makefile
endif

.PHONY: clean install deinstall clean
all:
	$(MAKE) -C src -f $(MFILE)

install:
	$(MAKE) -C src install

deinstall:
	$(MAKE) -C src deinstall

clean:
	$(MAKE) -C src clean

=== src/Makefile ===
INSTALL_DIR?=..
libdir=`([ -d /usr/lib64 ] && echo lib64) || echo lib`
LANG=C
CC=gcc -fopenmp
#CC=icc -openmp
CFLAGS+=-std=c99 -O2 -g -fPIC -Wall -pedantic
LDFLAGS=-lffindex -L.
ifdef FFINDEX_STATIC
	LDFLAGS+=-static
	FFINDEX_OBJECTS=libffindex.a
else
	FFINDEX_OBJECTS=libffindex.so libffindex.so.0.1 
endif

#-Wl,--version-script=libffindex.map

ifdef HAVE_MPI
all: ffindex_apply_mpi ffindex_apply ffindex_from_fasta ffindex_get ffindex_build ffindex_modify libffindex.a libffindex.so
else
all: ffindex_apply ffindex_from_fasta ffindex_get ffindex_build ffindex_modify libffindex.a libffindex.so
endif

ffindex.o: ffindex.c ffindex.h ffutil.h

ffindex_apply: $(FFINDEX_OBJECTS) ffindex_apply.o ffindex.h

ffindex_apply_mpi: $(FFINDEX_OBJECTS) ffindex_apply_mpi.o ffindex.h
	mpicc $(CFLAGS) -I $(MPI_INCLUDE) -o $@  ffindex_apply_mpi.o $(LDFLAGS)

ffindex_apply_mpi.o: ffindex_apply_mpi.c ffindex.h
	mpicc $(CFLAGS) -I $(MPI_INCLUDE) -c ffindex_apply_mpi.c -o $@ 

ffindex_from_fasta: $(FFINDEX_OBJECTS) ffindex_from_fasta.o ffindex.h
	$(CC) -o $@ ffindex_from_fasta.o $(LDFLAGS) -L. -lffindex

ffindex_get: $(FFINDEX_OBJECTS) ffindex_get.o ffindex.h
	$(CC) -o $@ ffindex_get.o $(LDFLAGS) -L. -lffindex

ffindex_build: $(FFINDEX_OBJECTS) ffindex_build.o ffindex.h
	$(CC) -o $@ ffindex_build.o $(LDFLAGS) -L. -lffindex

ffindex_modify: $(FFINDEX_OBJECTS) ffindex_modify.o ffindex.h
	$(CC) -o $@ ffindex_modify.o $(LDFLAGS) -L. -lffindex

libffindex.so.0.1: ffindex.o ffutil.o
	$(CC) -Wl,-z,defs -shared -Wl,-soname,libffindex.so.0.1 -o libffindex.so.0.1 ffindex.o ffutil.o -lc

libffindex.so: libffindex.so.0.1
	ln -sf libffindex.so.0.1 libffindex.so

libffindex.a: ffindex.o ffutil.o
	ar rcs libffindex.a ffutil.o ffindex.o 

test:
	rm -f /tmp/test.data /tmp/test.ffindex
	LD_LIBRARY_PATH=".:$(LD_LIBRARY_PATH)" ./ffindex_build -s /tmp/test.data /tmp/test.ffindex ../test/data ../test/data2
	LD_LIBRARY_PATH=".:$(LD_LIBRARY_PATH)" ./ffindex_get  /tmp/test.data /tmp/test.ffindex a b foo | tee /tmp/test.out
	LD_LIBRARY_PATH=".:$(LD_LIBRARY_PATH)" ./ffindex_modify -u /tmp/test.ffindex b
	LD_LIBRARY_PATH=".:$(LD_LIBRARY_PATH)" ./ffindex_get  /tmp/test.data /tmp/test.ffindex a b foo | tee /tmp/test-unlink.out
	LD_LIBRARY_PATH=".:$(LD_LIBRARY_PATH)" ./ffindex_build -a -s /tmp/test.data /tmp/test.ffindex ../test/testfile
	@echo ======== compare results =========
	diff /tmp/test.out test.should
	diff /tmp/test-unlink.out test-unlink.should
	@echo ======== error handling ==========
	@echo
	LD_LIBRARY_PATH=".:$(LD_LIBRARY_PATH)" ./ffindex_get  /tmp/test.data /tmp/test.ffindex nonexistquery b foo || echo
	LD_LIBRARY_PATH=".:$(LD_LIBRARY_PATH)" ./ffindex_get  /nonexist/data /tmp/test.ffindex a foo || echo
	LD_LIBRARY_PATH=".:$(LD_LIBRARY_PATH)" ./ffindex_get  /tmp/test.data /nonexist/index a foo || echo

time:
	LD_LIBRARY_PATH=".:$(LD_LIBRARY_PATH)" zsh -c "time ./ffindex_get  ../test_big/nr20_11Jan10_a3m_db ../test_big/nr20_11Jan10_a3m_db.ffindex BABBAMIBA.a3m KARDUZEBA.a3m HARPAQIBA.a3m WOQQATEBA.a3m BEBRAQIBA.a3m GIRSAKEBA.a3m NAQTIFIBA.a3m BIWCIQABA.a3m > /dev/null"

clean:
	rm -f ffindex.o ffutil.o ffindex_build ffindex_build.o ffindex_get ffindex_get.o libffindex.so libffindex.so.0.1 ffindex_modify ffindex_modify.o \
		libffindex.a  ffindex_from_fasta.o ffindex_from_fasta ffindex_apply_mpi.o ffindex_apply.o

install:
	mkdir -p $(INSTALL_DIR)/bin
	mkdir -p $(INSTALL_DIR)/$(libdir)
	mkdir -p $(INSTALL_DIR)/include
	install ffindex_get $(INSTALL_DIR)/bin/ffindex_get
	install ffindex_build $(INSTALL_DIR)/bin/ffindex_build
	install ffindex_modify $(INSTALL_DIR)/bin/ffindex_modify
	install ffindex_from_fasta $(INSTALL_DIR)/bin/ffindex_from_fasta
	install ffindex_apply $(INSTALL_DIR)/bin/ffindex_apply
	install libffindex.so.0.1 $(INSTALL_DIR)/$(libdir)/libffindex.so.0.1
	install libffindex.a $(INSTALL_DIR)/$(libdir)/libffindex.a
	ln -sf libffindex.so.0.1 $(INSTALL_DIR)/$(libdir)/libffindex.so
	install ffindex.h $(INSTALL_DIR)/include/ffindex.h
	install ffutil.h $(INSTALL_DIR)/include/ffutil.h
ifdef HAVE_MPI
	install ffindex_apply_mpi $(INSTALL_DIR)/bin/ffindex_apply_mpi
endif

deinstall:
	rm -f $(INSTALL_DIR)/bin/ffindex_get $(INSTALL_DIR)/bin/ffindex_build $(INSTALL_DIR)/bin/ffindex_modify \
		$(INSTALL_DIR)/$(libdir)/libffindex.so.0.1 $(INSTALL_DIR)/$(libdir)/libffindex.a \
		$(INSTALL_DIR)/$(libdir)/libffindex.so $(INSTALL_DIR)/include/ffindex.h $(INSTALL_DIR)/include/ffutil.h\
		$(INSTALL_DIR)/bin/ffindex_from_fasta
	rmdir $(INSTALL_DIR)/bin || true
	rmdir $(INSTALL_DIR)/$(libdir) || true
	rmdir $(INSTALL_DIR)/include || true

=== debian/changelog ===
ffindex (0.9.6.1-1) unstable; urgency=low

  * New upstream release.
  * Fixed many bugs.

 -- Laszlo Kajan <lkajan@rostlab.org>  Tue, 26 Jun 2012 11:43:41 +0200

ffindex (0.9.3-2) unstable; urgency=low

  * Included full text of CC-BY-SA-3.0 license (Closes: #667698)

 -- Laszlo Kajan <lkajan@rostlab.org>  Mon, 23 Apr 2012 11:30:03 +0200

=== debian/control ===
Source: ffindex
Section: science
Priority: extra
Maintainer: Debian Med Packaging Team <debian-med-packaging@lists.alioth.debian.org>
Uploaders: Laszlo Kajan <lkajan@rostlab.org>
Build-Depends: debhelper (>= 8.0.0), help2man
Standards-Version: 3.9.3
Homepage: http://pubshare.genzentrum.lmu.de/scientific_computing/software/ffindex/
Vcs-Svn: svn://svn.debian.org/debian-med/trunk/packages/ffindex/trunk/
Vcs-Browser: http://svn.debian.org/wsvn/debian-med/trunk/packages/ffindex/trunk/
DM-Upload-Allowed: yes

Package: ffindex
Architecture: any
Depends: libffindex0 (= ${binary:Version}), ${shlibs:Depends}, ${misc:Depends}
Description: simple index/database for huge amounts of small files
 FFindex is a very simple index/database for huge amounts of small files. The
 files are stored concatenated in one big data file, separated by '\0'. A
 second file contains a plain text index, giving name, offset and length of
 the small files. The lookup is currently done with a binary search on an
 array made from the index file.
 .
 This package provides the executables.

Package: libffindex0
Architecture: any
Section: libs
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: library for simple index/database for huge amounts of small files
 FFindex is a very simple index/database for huge amounts of small files. The
 files are stored concatenated in one big data file, separated by '\0'. A
 second file contains a plain text index, giving name, offset and length of
 the small files. The lookup is currently done with a binary search on an
 array made from the index file.
 .
 This package provides the shared library.

Package: libffindex0-dev
Architecture: any
Section: libdevel
Depends: libffindex0 (= ${binary:Version}), ${misc:Depends}
Provides: libffindex-dev
Description: library for simple index/database for huge amounts of small files (development)
 FFindex is a very simple index/database for huge amounts of small files. The
 files are stored concatenated in one big data file, separated by '\0'. A
 second file contains a plain text index, giving name, offset and length of
 the small files. The lookup is currently done with a binary search on an
 array made from the index file.
 .
 This package contains the header files and documentation needed to develop
 applications with libffindex.

Package: ffindex-dbg
Architecture: any
Section: debug
Depends: ffindex (= ${binary:Version}), libffindex0 (= ${binary:Version}), ${misc:Depends}
Description: simple index/database for huge amounts of small files (debug)
 FFindex is a very simple index/database for huge amounts of small files. The
 files are stored concatenated in one big data file, separated by '\0'. A
 second file contains a plain text index, giving name, offset and length of
 the small files. The lookup is currently done with a binary search on an
 array made from the index file.
 .
 This package provides the detached debug symbols for ffindex and libffindex.

=== debian/rules ===
#!/usr/bin/make -f

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

%:
	dh $@ --parallel

FFMANPAGES = ffindex_apply.1 ffindex_build.1 ffindex_from_fasta.1 ffindex_get.1 ffindex_modify.1
.PHONY: ffmanpages
ffmanpages: $(FFMANPAGES)
BINNAMES =	\
		ffindex_apply="apply a program to each FFindex entry";\
		ffindex_build="build file index from files in directories";\
		ffindex_from_fasta="populate index from FASTA file";\
		ffindex_get="retrieve entries from file index";\
		ffindex_modify="modify file index entries";\

.PHONY: override_dh_installman
override_dh_installman: $(FFMANPAGES)
	dh_installman

$(FFMANPAGES): %.1 : debian/tmp/usr/bin/%
	unset LD_PRELOAD && export LD_LIBRARY_PATH=debian/tmp/usr/lib && eval '$(BINNAMES)' && help2man --no-info --no-discard-stderr '--help-option= ' -n "$$$*" --version-option="-v" '$<' -o '$@' --include debian/man_notes.nroff

.PHONY: override_dh_clean
override_dh_clean:
	rm -f $(FFMANPAGES)
	dh_clean

.PHONY: override_dh_strip
override_dh_strip:
	dh_strip --dbg-package=ffindex-dbg

# [Laszlo Kajan <lkajan@rostlab.org>]
# ffindex has an overly large default for FFINDEX_MAX_INDEX_ENTRIES (40000000). In order to require less RAM for testing the package (make check), a more modest value is set below.
.PHONY: override_dh_auto_test
override_dh_auto_test:
	dh_auto_test -- FFINDEX_MAX_INDEX_ENTRIES=20000

get-orig-source:
	mkdir -p ../tarballs
	uscan --verbose --force-download --destdir=../tarballs

=== debian/watch ===
version=3

# Homepage  Pattern  [Version  [Action]]
http://pubshare.genzentrum.lmu.de/scientific_computing/software/ffindex/ \
            ffindex-([0-9][0-9.]*)\.tar\.[gzbl2]{2,3}

## ffindex 0.9.9

=== debian/changelog ===
ffindex (0.9.9-2) unstable; urgency=low

  * Fixed 'bc' not found issue in d/rules (Closes: #696285).

 -- Laszlo Kajan <lkajan@rostlab.org>  Wed, 19 Dec 2012 00:39:51 +0100

ffindex (0.9.9-1) unstable; urgency=low

  * New upstream release

 -- Laszlo Kajan <lkajan@rostlab.org>  Sun, 16 Dec 2012 14:47:49 +0100

ffindex (0.9.8-1) unstable; urgency=low

  * New upstream release.
  * Added symbols control file.

 -- Laszlo Kajan <lkajan@rostlab.org>  Wed, 27 Jun 2012 15:27:47 +0200

=== debian/rules ===
--- 
+++ 
@@ -3,10 +3,18 @@
 # Uncomment this to turn on verbose mode.
 #export DH_VERBOSE=1
 
+export CPPFLAGS:=$(shell dpkg-buildflags --get CPPFLAGS)
+export CFLAGS:=$(shell dpkg-buildflags --get CFLAGS)
+export CXXFLAGS:=$(shell dpkg-buildflags --get CXXFLAGS)
+export LDFLAGS:=$(shell dpkg-buildflags --get LDFLAGS)
+
+# lkajan: work in progress, enable this in next upstream release, after speaking to upstream
+#export HAVE_MPI:=1
+
 %:
 	dh $@ --parallel
 
-FFMANPAGES = ffindex_apply.1 ffindex_build.1 ffindex_from_fasta.1 ffindex_get.1 ffindex_modify.1
+FFMANPAGES = ffindex_apply.1 ffindex_build.1 ffindex_from_fasta.1 ffindex_get.1 ffindex_modify.1 ffindex_unpack.1
 .PHONY: ffmanpages
 ffmanpages: $(FFMANPAGES)
 BINNAMES =	\
@@ -15,6 +23,7 @@
 		ffindex_from_fasta="populate index from FASTA file";\
 		ffindex_get="retrieve entries from file index";\
 		ffindex_modify="modify file index entries";\
+		ffindex_unpack="unpack file index entries";
 
 .PHONY: override_dh_installman
 override_dh_installman: $(FFMANPAGES)

## ffindex 0.9.9.1

=== debian/changelog ===
ffindex (0.9.9.1-1) unstable; urgency=low

  * New upstream release. Shared library sources did not change.

 -- Laszlo Kajan <lkajan@rostlab.org>  Thu, 16 May 2013 14:40:05 +0200

## ffindex 0.9.9.3

=== src/Makefile ===
--- 
+++ 
@@ -3,7 +3,7 @@
 LANG=C
 CC=gcc -fopenmp
 #CC=icc -openmp
-CFLAGS+=-std=c99 -O2 -g -fPIC -Wall -pedantic
+CFLAGS+=-std=c99 -O2 -g -fPIC -Wall -pedantic -D_GNU_SOURCE=1
 LDFLAGS=-lffindex -L.
 ifdef FFINDEX_STATIC
 	LDFLAGS+=-static
@@ -14,21 +14,23 @@
 
 #-Wl,--version-script=libffindex.map
 
+OBJECTS=ffindex_apply ffindex_from_fasta ffindex_get ffindex_build ffindex_modify libffindex.a libffindex.so ffindex_unpack
+
 ifdef HAVE_MPI
-all: ffindex_apply_mpi ffindex_apply ffindex_from_fasta ffindex_get ffindex_build ffindex_modify libffindex.a libffindex.so
-else
-all: ffindex_apply ffindex_from_fasta ffindex_get ffindex_build ffindex_modify libffindex.a libffindex.so
+OBJECTS+=ffindex_apply_mpi
 endif
+
+all: $(OBJECTS)
 
 ffindex.o: ffindex.c ffindex.h ffutil.h
 
 ffindex_apply: $(FFINDEX_OBJECTS) ffindex_apply.o ffindex.h
 
 ffindex_apply_mpi: $(FFINDEX_OBJECTS) ffindex_apply_mpi.o ffindex.h
-	mpicc $(CFLAGS) -I $(MPI_INCLUDE) -o $@  ffindex_apply_mpi.o $(LDFLAGS)
+	mpicc $(CFLAGS) -o $@  ffindex_apply_mpi.o $(LDFLAGS)
 
 ffindex_apply_mpi.o: ffindex_apply_mpi.c ffindex.h
-	mpicc $(CFLAGS) -I $(MPI_INCLUDE) -c ffindex_apply_mpi.c -o $@ 
+	mpicc $(CFLAGS) -c ffindex_apply_mpi.c -o $@ 
 
 ffindex_from_fasta: $(FFINDEX_OBJECTS) ffindex_from_fasta.o ffindex.h
 	$(CC) -o $@ ffindex_from_fasta.o $(LDFLAGS) -L. -lffindex
@@ -41,6 +43,9 @@
 
 ffindex_modify: $(FFINDEX_OBJECTS) ffindex_modify.o ffindex.h
 	$(CC) -o $@ ffindex_modify.o $(LDFLAGS) -L. -lffindex
+
+ffindex_unpack: $(FFINDEX_OBJECTS) ffindex_unpack.o ffindex.h
+	$(CC) -o $@ ffindex_unpack.o $(LDFLAGS) -L. -lffindex
 
 libffindex.so.0.1: ffindex.o ffutil.o
 	$(CC) -Wl,-z,defs -shared -Wl,-soname,libffindex.so.0.1 -o libffindex.so.0.1 ffindex.o ffutil.o -lc
@@ -83,6 +88,7 @@
 	install ffindex_modify $(INSTALL_DIR)/bin/ffindex_modify
 	install ffindex_from_fasta $(INSTALL_DIR)/bin/ffindex_from_fasta
 	install ffindex_apply $(INSTALL_DIR)/bin/ffindex_apply
+	install ffindex_unpack $(INSTALL_DIR)/bin/ffindex_unpack
 	install libffindex.so.0.1 $(INSTALL_DIR)/$(libdir)/libffindex.so.0.1
 	install libffindex.a $(INSTALL_DIR)/$(libdir)/libffindex.a
 	ln -sf libffindex.so.0.1 $(INSTALL_DIR)/$(libdir)/libffindex.so

=== debian/changelog ===
ffindex (0.9.9.3-1) unstable; urgency=low

  * New upstream release.
  * Up-to-date standards-version.
  * Vcs fields updated.

 -- Laszlo Kajan <lkajan@debian.org>  Mon, 25 Nov 2013 20:01:02 +0100

=== debian/control ===
--- 
+++ 
@@ -2,13 +2,12 @@
 Section: science
 Priority: extra
 Maintainer: Debian Med Packaging Team <debian-med-packaging@lists.alioth.debian.org>
-Uploaders: Laszlo Kajan <lkajan@rostlab.org>
+Uploaders: Laszlo Kajan <lkajan@debian.org>
 Build-Depends: debhelper (>= 8.0.0), help2man
-Standards-Version: 3.9.3
-Homepage: http://pubshare.genzentrum.lmu.de/scientific_computing/software/ffindex/
-Vcs-Svn: svn://svn.debian.org/debian-med/trunk/packages/ffindex/trunk/
-Vcs-Browser: http://svn.debian.org/wsvn/debian-med/trunk/packages/ffindex/trunk/
-DM-Upload-Allowed: yes
+Standards-Version: 3.9.4
+Homepage: http://www.splashground.de/~andy/programs/FFindex/
+Vcs-Svn: svn://anonscm.debian.org/debian-med/trunk/packages/ffindex/trunk/
+Vcs-Browser: http://anonscm.debian.org/viewvc/debian-med/trunk/packages/ffindex/trunk/
 
 Package: ffindex
 Architecture: any

=== debian/rules ===
--- 
+++ 
@@ -45,7 +45,7 @@
 # ffindex has an overly large default for FFINDEX_MAX_INDEX_ENTRIES (40000000). In order to require less RAM for testing the package (make check), a more modest value is set below.
 .PHONY: override_dh_auto_test
 override_dh_auto_test:
-	dh_auto_test -- FFINDEX_MAX_INDEX_ENTRIES=20000
+	dh_auto_test -- FFINDEX_MAX_INDEX_ENTRIES=20000 check
 
 get-orig-source:
 	mkdir -p ../tarballs

=== debian/watch ===
version=3

# Homepage  Pattern  [Version  [Action]]
http://www.splashground.de/~andy/programs/FFindex/ \
	ffindex-([0-9][0-9.]*)\.tar\.[gzbl2]{2,3}

## ffindex 0.9.9.6

=== src/Makefile ===
--- 
+++ 
@@ -1,10 +1,16 @@
 INSTALL_DIR?=..
 libdir=`([ -d /usr/lib64 ] && echo lib64) || echo lib`
 LANG=C
-CC=gcc -fopenmp
-#CC=icc -openmp
-CFLAGS+=-std=c99 -O2 -g -fPIC -Wall -pedantic -D_GNU_SOURCE=1
+#CC=musl-gcc
+#OMPI_CC=musl-gcc
+CC=gcc
+#CC=icc
+#CC=clang
+CFLAGS+=-std=c99 -O2 -g -fPIC -Wall -pedantic -D_GNU_SOURCE=1 -I.
 LDFLAGS=-lffindex -L.
+
+OS:= $(shell uname)
+
 ifdef FFINDEX_STATIC
 	LDFLAGS+=-static
 	FFINDEX_OBJECTS=libffindex.a
@@ -12,9 +18,7 @@
 	FFINDEX_OBJECTS=libffindex.so libffindex.so.0.1 
 endif
 
-#-Wl,--version-script=libffindex.map
-
-OBJECTS=ffindex_apply ffindex_from_fasta ffindex_get ffindex_build ffindex_modify libffindex.a libffindex.so ffindex_unpack
+OBJECTS=ffindex_apply ffindex_from_fasta ffindex_get ffindex_build ffindex_modify libffindex.a libffindex.so ffindex_unpack ffindex_from_tsv
 
 ifdef HAVE_MPI
 OBJECTS+=ffindex_apply_mpi
@@ -22,18 +26,34 @@
 
 all: $(OBJECTS)
 
-ffindex.o: ffindex.c ffindex.h ffutil.h
+ext/fmemopen.o: ext/fmemopen.c
+	make -C ext
+
+ffindex.o: ffindex.c ffindex.h ffutil.h ffindex_posix_search.h
+
+ffindex_apply.o: ffindex_apply_mpi.c ffindex.h
+	$(CC) $(CFLAGS) -c ffindex_apply_mpi.c -o $@ 
 
 ffindex_apply: $(FFINDEX_OBJECTS) ffindex_apply.o ffindex.h
+	$(CC) $(CFLAGS) -o $@  ffindex_apply.o $(LDFLAGS)
 
 ffindex_apply_mpi: $(FFINDEX_OBJECTS) ffindex_apply_mpi.o ffindex.h
-	mpicc $(CFLAGS) -o $@  ffindex_apply_mpi.o $(LDFLAGS)
+	mpicc $(CFLAGS) -DHAVE_MPI -o $@  ffindex_apply_mpi.o $(LDFLAGS)
 
 ffindex_apply_mpi.o: ffindex_apply_mpi.c ffindex.h
-	mpicc $(CFLAGS) -c ffindex_apply_mpi.c -o $@ 
+	mpicc $(CFLAGS) -DHAVE_MPI -c ffindex_apply_mpi.c -o $@ 
+
+ffindex_apply_mpi_spawn: $(FFINDEX_OBJECTS) ffindex_apply_mpi_spawn.o ffindex.h
+	mpicc $(CFLAGS) -o $@  ffindex_apply_mpi_spawn.o $(LDFLAGS)
+
+ffindex_apply_mpi_spawn.o: ffindex_apply_mpi_spawn.c ffindex.h
+	mpicc $(CFLAGS) -c ffindex_apply_mpi_spawn.c -o $@ 
 
 ffindex_from_fasta: $(FFINDEX_OBJECTS) ffindex_from_fasta.o ffindex.h
 	$(CC) -o $@ ffindex_from_fasta.o $(LDFLAGS) -L. -lffindex
+
+ffindex_from_tsv: $(FFINDEX_OBJECTS) ffindex_from_tsv.o ffindex.h
+	$(CC) -o $@ ffindex_from_tsv.o $(LDFLAGS) -L. -lffindex
 
 ffindex_get: $(FFINDEX_OBJECTS) ffindex_get.o ffindex.h
 	$(CC) -o $@ ffindex_get.o $(LDFLAGS) -L. -lffindex
@@ -47,14 +67,19 @@
 ffindex_unpack: $(FFINDEX_OBJECTS) ffindex_unpack.o ffindex.h
 	$(CC) -o $@ ffindex_unpack.o $(LDFLAGS) -L. -lffindex
 
-libffindex.so.0.1: ffindex.o ffutil.o
-	$(CC) -Wl,-z,defs -shared -Wl,-soname,libffindex.so.0.1 -o libffindex.so.0.1 ffindex.o ffutil.o -lc
+ifeq ($(OS), Darwin)
+libffindex.so.0.1: ffindex.o ffutil.o ffindex_posix_search.o ext/fmemopen.o
+		$(CC) -shared -o libffindex.so.0.1 $^
+else
+libffindex.so.0.1: ffindex.o ffutil.o ffindex_posix_search.o
+		$(CC) -Wl,-z,defs -Wl,-soname,libffindex.so.0.1 -shared -o libffindex.so.0.1 $^
+endif
 
 libffindex.so: libffindex.so.0.1
 	ln -sf libffindex.so.0.1 libffindex.so
 
-libffindex.a: ffindex.o ffutil.o
-	ar rcs libffindex.a ffutil.o ffindex.o 
+libffindex.a: ffindex.o ffutil.o ffindex_posix_search.o
+	ar rcs libffindex.a $^
 
 test:
 	rm -f /tmp/test.data /tmp/test.ffindex
@@ -76,8 +101,10 @@
 	LD_LIBRARY_PATH=".:$(LD_LIBRARY_PATH)" zsh -c "time ./ffindex_get  ../test_big/nr20_11Jan10_a3m_db ../test_big/nr20_11Jan10_a3m_db.ffindex BABBAMIBA.a3m KARDUZEBA.a3m HARPAQIBA.a3m WOQQATEBA.a3m BEBRAQIBA.a3m GIRSAKEBA.a3m NAQTIFIBA.a3m BIWCIQABA.a3m > /dev/null"
 
 clean:
-	rm -f ffindex.o ffutil.o ffindex_build ffindex_build.o ffindex_get ffindex_get.o libffindex.so libffindex.so.0.1 ffindex_modify ffindex_modify.o \
-		libffindex.a  ffindex_from_fasta.o ffindex_from_fasta ffindex_apply_mpi.o ffindex_apply.o
+	rm -f ffindex.o ffutil.o ffindex_build ffindex_build.o ffindex_get ffindex_get.o libffindex.so libffindex.so.0.1 \
+		ffindex_modify ffindex_modify.o libffindex.a  ffindex_from_fasta.o ffindex_from_fasta ffindex_apply_mpi.o \
+		ffindex_apply.o ffindex_apply ffindex_from_tsv ffindex_khget ffindex_unpack ffindex_from_tsv.o ffindex_unpack.o \
+		ffindex_posix_search.o
 
 install:
 	mkdir -p $(INSTALL_DIR)/bin

=== debian/changelog ===
ffindex (0.9.9.6-2) unstable; urgency=medium

  * Install ffindex_posix_search.h (see #802076)

 -- Andreas Tille <tille@debian.org>  Sun, 18 Oct 2015 00:24:22 +0200

ffindex (0.9.9.6-1) unstable; urgency=medium

  * New upstream version
  * Remove symbols file
  * DEP5
  * cme fix dpkg-control

 -- Andreas Tille <tille@debian.org>  Tue, 15 Sep 2015 08:09:23 +0200

ffindex (0.9.9.3-2) unstable; urgency=medium

  * Build with clang (thanks for the patch to Alexander <sanek23994@gmail.com>)
    Closes: #758149
  * debian/control:
     - add myself to Uploaders
     - Priotity: optional
     - debhelper 9
     - cme fix dpkg-control

 -- Andreas Tille <tille@debian.org>  Fri, 15 Aug 2014 09:25:28 +0200

=== debian/control ===
--- 
+++ 
@@ -1,17 +1,23 @@
 Source: ffindex
+Maintainer: Debian Med Packaging Team <debian-med-packaging@lists.alioth.debian.org>
+Uploaders: Laszlo Kajan <lkajan@debian.org>,
+           Andreas Tille <tille@debian.org>
 Section: science
-Priority: extra
-Maintainer: Debian Med Packaging Team <debian-med-packaging@lists.alioth.debian.org>
-Uploaders: Laszlo Kajan <lkajan@debian.org>
-Build-Depends: debhelper (>= 8.0.0), help2man
-Standards-Version: 3.9.4
+Priority: optional
+Build-Depends: debhelper (>= 9),
+               help2man,
+#               libopenmpi-dev,
+#               openmpi-bin  ... needs another Build-Depends to create the manpage - but which one?
+Standards-Version: 3.9.6
+Vcs-Browser: http://anonscm.debian.org/viewvc/debian-med/trunk/packages/ffindex/trunk/
+Vcs-Svn: svn://anonscm.debian.org/debian-med/trunk/packages/ffindex/trunk/
 Homepage: http://www.splashground.de/~andy/programs/FFindex/
-Vcs-Svn: svn://anonscm.debian.org/debian-med/trunk/packages/ffindex/trunk/
-Vcs-Browser: http://anonscm.debian.org/viewvc/debian-med/trunk/packages/ffindex/trunk/
 
 Package: ffindex
 Architecture: any
-Depends: libffindex0 (= ${binary:Version}), ${shlibs:Depends}, ${misc:Depends}
+Depends: libffindex0 (= ${binary:Version}),
+         ${shlibs:Depends},
+         ${misc:Depends}
 Description: simple index/database for huge amounts of small files
  FFindex is a very simple index/database for huge amounts of small files. The
  files are stored concatenated in one big data file, separated by '\0'. A
@@ -24,7 +30,8 @@
 Package: libffindex0
 Architecture: any
 Section: libs
-Depends: ${shlibs:Depends}, ${misc:Depends}
+Depends: ${shlibs:Depends},
+         ${misc:Depends}
 Description: library for simple index/database for huge amounts of small files
  FFindex is a very simple index/database for huge amounts of small files. The
  files are stored concatenated in one big data file, separated by '\0'. A
@@ -37,7 +44,8 @@
 Package: libffindex0-dev
 Architecture: any
 Section: libdevel
-Depends: libffindex0 (= ${binary:Version}), ${misc:Depends}
+Depends: libffindex0 (= ${binary:Version}),
+         ${misc:Depends}
 Provides: libffindex-dev
 Description: library for simple index/database for huge amounts of small files (development)
  FFindex is a very simple index/database for huge amounts of small files. The
@@ -52,7 +60,10 @@
 Package: ffindex-dbg
 Architecture: any
 Section: debug
-Depends: ffindex (= ${binary:Version}), libffindex0 (= ${binary:Version}), ${misc:Depends}
+Priority: extra
+Depends: ffindex (= ${binary:Version}),
+         libffindex0 (= ${binary:Version}),
+         ${misc:Depends}
 Description: simple index/database for huge amounts of small files (debug)
  FFindex is a very simple index/database for huge amounts of small files. The
  files are stored concatenated in one big data file, separated by '\0'. A

=== debian/rules ===
#!/usr/bin/make -f

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

# lkajan: work in progress, enable this in next upstream release, after speaking to upstream
# tille@d.o: If enabled only ffindex_apply_mpi and for creating the manpage another (not yet
#            known) Build-Depends is needed.
# export HAVE_MPI:=1

%:
	dh $@ --parallel

FFMANPAGES = ffindex_apply.1 ffindex_build.1 ffindex_from_fasta.1 ffindex_get.1 ffindex_modify.1 ffindex_unpack.1
# ffindex_apply_mpi.1
ffmanpages: $(FFMANPAGES)
BINNAMES =	\
		ffindex_apply="apply a program to each FFindex entry";\
		ffindex_build="build file index from files in directories";\
		ffindex_from_fasta="populate index from FASTA file";\
		ffindex_get="retrieve entries from file index";\
		ffindex_modify="modify file index entries";\
		ffindex_unpack="unpack file index entries";
#		ffindex_apply_mpi="apply a program to each FFindex entry (mpi enhanced)";\

override_dh_installman: $(FFMANPAGES)
	dh_installman

$(FFMANPAGES): %.1 : debian/tmp/usr/bin/%
	unset LD_PRELOAD && export LD_LIBRARY_PATH=debian/tmp/usr/lib && eval '$(BINNAMES)' && help2man --no-info --no-discard-stderr '--help-option= ' -n "$$$*" --version-option="-v" '$<' -o '$@' --include debian/man_notes.nroff

override_dh_clean:
	rm -f $(FFMANPAGES)
	dh_clean

override_dh_strip:
	dh_strip --dbg-package=ffindex-dbg

# [Laszlo Kajan <lkajan@rostlab.org>]
# ffindex has an overly large default for FFINDEX_MAX_INDEX_ENTRIES (40000000). In order to require less RAM for testing the package (make check), a more modest value is set below.
override_dh_auto_test:
	dh_auto_test -- FFINDEX_MAX_INDEX_ENTRIES=20000 check

get-orig-source:
	mkdir -p ../tarballs
	uscan --verbose --force-download --destdir=../tarballs

## ffindex 0.9.9.7

=== Makefile ===
all:
	$(MAKE) -C src $@

%:
	$(MAKE) -C src $@

release:
	git archive HEAD --prefix "ffindex-`cat VERSION`/" -o "ffindex-`cat VERSION`.tar.gz"

relnotes:
	git log --pretty=format:" - %s%n%b"

=== src/Makefile ===
INSTALL_DIR?=..
libdir=`([ -d /usr/lib64 ] && echo lib64) || echo lib`
LANG=C
#CC=musl-gcc
#OMPI_CC=musl-gcc
#CC=gcc
#CC=icc
#CC=clang
CFLAGS+=-std=c99 -O2 -g -fPIC -Wall -pedantic -D_GNU_SOURCE=1 -I.
LDFLAGS=-lffindex -L.

OS:= $(shell uname)

FFINDEX_LIBS=libffindex.so libffindex.so.0.1 libffindex.a

FFINDEX_HEADERS=ffindex.h ffindex_posix_search.h ffutil.h
FFINDEX_OBJECTS=$(FFINDEX_HEADERS:.h=.o)

FFINDEX_PROGRAMS=ffindex_apply ffindex_from_fasta ffindex_get ffindex_build ffindex_modify ffindex_unpack ffindex_from_tsv

ifdef HAVE_MPI
FFINDEX_PROGRAMS+=ffindex_apply_mpi
endif

all: $(FFINDEX_LIBS) $(FFINDEX_PROGRAMS)

# for Darwin only
ext/fmemopen.o: ext/fmemopen.c
	make -C ext

ffindex.o: ffindex.c $(FFINDEX_HEADERS)

libffindex.a: $(FFINDEX_OBJECTS)
	ar rcs libffindex.a $^

ifeq ($(OS), Darwin)
libffindex.so.0.1: $(FFINDEX_OBJECTS) ext/fmemopen.o
		$(CC) -shared -o libffindex.so.0.1 $^
else

 ifdef FFINDEX_STATIC
STATIC=-static
 endif

libffindex.so.0.1: $(FFINDEX_OBJECTS)
		$(CC) -Wl,-z,defs -Wl,-soname,libffindex.so.0.1 -shared -o libffindex.so.0.1 $^

endif

libffindex.so: libffindex.so.0.1
	ln -sf libffindex.so.0.1 libffindex.so

ffindex_apply.o: ffindex_apply_mpi.c $(FFINDEX_LIBS)
	$(CC) $(CFLAGS) -c ffindex_apply_mpi.c -o $@ 

ffindex_apply: ffindex_apply.o $(FFINDEX_LIBS)
	$(CC) $(CFLAGS) -o $@  ffindex_apply.o $(LDFLAGS) $(STATIC)

ffindex_apply_mpi: ffindex_apply_mpi.o $(FFINDEX_LIBS)
	mpicc $(CFLAGS) -DHAVE_MPI -o $@  ffindex_apply_mpi.o $(LDFLAGS)

ffindex_apply_mpi.o: ffindex_apply_mpi.c $(FFINDEX_HEADERS)
	mpicc $(CFLAGS) -DHAVE_MPI -c ffindex_apply_mpi.c -o $@ 

ffindex_apply_mpi_spawn: ffindex_apply_mpi_spawn.o $(FFINDEX_LIBS)
	mpicc $(CFLAGS) -o $@  ffindex_apply_mpi_spawn.o $(LDFLAGS)

ffindex_apply_mpi_spawn.o: ffindex_apply_mpi_spawn.o $(FFINDEX_HEADERS)
	mpicc $(CFLAGS) -c ffindex_apply_mpi_spawn.c -o $@ 

ffindex_from_fasta: ffindex_from_fasta.o $(FFINDEX_LIBS)
	$(CC) -o $@ ffindex_from_fasta.o $(LDFLAGS) $(STATIC)

ffindex_from_tsv: ffindex_from_tsv.o $(FFINDEX_LIBS)
	$(CC) -o $@ ffindex_from_tsv.o $(LDFLAGS) $(STATIC)

ffindex_get: ffindex_get.o $(FFINDEX_LIBS)
	$(CC) -o $@ ffindex_get.o $(LDFLAGS) $(STATIC)

ffindex_build: ffindex_build.o $(FFINDEX_LIBS)
	$(CC) -o $@ ffindex_build.o $(LDFLAGS) $(STATIC)

ffindex_modify: ffindex_modify.o $(FFINDEX_LIBS)
	$(CC) -o $@ ffindex_modify.o $(LDFLAGS) $(STATIC)

ffindex_unpack: ffindex_unpack.o $(FFINDEX_LIBS)
	$(CC) -o $@ ffindex_unpack.o $(LDFLAGS) $(STATIC)

test:
	rm -f /tmp/test.data /tmp/test.ffindex
	LD_LIBRARY_PATH=".:$(LD_LIBRARY_PATH)" ./ffindex_build -s /tmp/test.data /tmp/test.ffindex ../test/data ../test/data2
	LD_LIBRARY_PATH=".:$(LD_LIBRARY_PATH)" ./ffindex_get  /tmp/test.data /tmp/test.ffindex a b foo | tee /tmp/test.out
	LD_LIBRARY_PATH=".:$(LD_LIBRARY_PATH)" ./ffindex_modify -u /tmp/test.ffindex b
	LD_LIBRARY_PATH=".:$(LD_LIBRARY_PATH)" ./ffindex_get  /tmp/test.data /tmp/test.ffindex a b foo | tee /tmp/test-unlink.out
	LD_LIBRARY_PATH=".:$(LD_LIBRARY_PATH)" ./ffindex_build -a -s /tmp/test.data /tmp/test.ffindex ../test/testfile
	@echo ======== compare results =========
	diff /tmp/test.out test.should
	diff /tmp/test-unlink.out test-unlink.should
	@echo ======== error handling ==========
	@echo
	LD_LIBRARY_PATH=".:$(LD_LIBRARY_PATH)" ./ffindex_get  /tmp/test.data /tmp/test.ffindex nonexistquery b foo || echo
	LD_LIBRARY_PATH=".:$(LD_LIBRARY_PATH)" ./ffindex_get  /nonexist/data /tmp/test.ffindex a foo || echo
	LD_LIBRARY_PATH=".:$(LD_LIBRARY_PATH)" ./ffindex_get  /tmp/test.data /nonexist/index a foo || echo

time:
	LD_LIBRARY_PATH=".:$(LD_LIBRARY_PATH)" zsh -c "time ./ffindex_get  ../test_big/nr20_11Jan10_a3m_db ../test_big/nr20_11Jan10_a3m_db.ffindex BABBAMIBA.a3m KARDUZEBA.a3m HARPAQIBA.a3m WOQQATEBA.a3m BEBRAQIBA.a3m GIRSAKEBA.a3m NAQTIFIBA.a3m BIWCIQABA.a3m > /dev/null"

clean:
	rm -f $(FFINDEX_PROGRAMS) $(FFINDEX_OBJECTS) $(FFINDEX_LIBS) \
		libffindex.so libffindex.so.0.1 libffindex.a \
		ffindex_build.o ffindex_get.o ffindex_modify.o ffindex_from_fasta.o ffindex_apply_mpi.o \
		ffindex_apply.o ffindex_from_tsv.o ffindex_unpack.o ffindex_posix_search.o ffindex_apply_mpi_spawn.o

install:
	mkdir -p $(INSTALL_DIR)/bin
	mkdir -p $(INSTALL_DIR)/$(libdir)
	mkdir -p $(INSTALL_DIR)/include
	install ffindex_get $(INSTALL_DIR)/bin/ffindex_get
	install ffindex_build $(INSTALL_DIR)/bin/ffindex_build
	install ffindex_modify $(INSTALL_DIR)/bin/ffindex_modify
	install ffindex_from_fasta $(INSTALL_DIR)/bin/ffindex_from_fasta
	install ffindex_from_tsv $(INSTALL_DIR)/bin/ffindex_from_tsv
	install ffindex_apply $(INSTALL_DIR)/bin/ffindex_apply
	install ffindex_unpack $(INSTALL_DIR)/bin/ffindex_unpack
	install libffindex.so.0.1 $(INSTALL_DIR)/$(libdir)/libffindex.so.0.1
	install libffindex.a $(INSTALL_DIR)/$(libdir)/libffindex.a
	ln -sf libffindex.so.0.1 $(INSTALL_DIR)/$(libdir)/libffindex.so
	install ffindex.h $(INSTALL_DIR)/include/ffindex.h
	install ffutil.h $(INSTALL_DIR)/include/ffutil.h
	install ffindex_posix_search.h $(INSTALL_DIR)/include/ffindex_posix_search.h
ifdef HAVE_MPI
	install ffindex_apply_mpi $(INSTALL_DIR)/bin/ffindex_apply_mpi
endif

deinstall:
	rm -f $(INSTALL_DIR)/bin/ffindex_get $(INSTALL_DIR)/bin/ffindex_build $(INSTALL_DIR)/bin/ffindex_modify \
		$(INSTALL_DIR)/$(libdir)/libffindex.so.0.1 $(INSTALL_DIR)/$(libdir)/libffindex.a \
		$(INSTALL_DIR)/$(libdir)/libffindex.so $(INSTALL_DIR)/include/ffindex.h $(INSTALL_DIR)/include/ffutil.h\
		$(INSTALL_DIR)/include/ffindex_posix_search.h $(INSTALL_DIR)/bin/ffindex_from_fasta $(INSTALL_DIR)/bin/ffindex_from_tsv
	rmdir $(INSTALL_DIR)/bin || true
	rmdir $(INSTALL_DIR)/$(libdir) || true
	rmdir $(INSTALL_DIR)/include || true

=== debian/changelog ===
ffindex (0.9.9.7-4) unstable; urgency=medium

  * Team upload
  * Fix autopkgtest: (Closes: #851658)
    - Really limit the amount of RAM needed
    - Sort the ffindex before querying or unlinking
  * Update debian/copyright
  * Drop debian/libffindex0.lintian-overrides and
    debian/README.source, no longer required
  * Generate manpages for ffindex_apply_mpi and ffindex_from_tsv
  * Pass CPPFLAGS and LDFLAGS for hardening
  * Bump Standards-Version to 4.0.0, no further changes

 -- Graham Inggs <ginggs@debian.org>  Thu, 29 Jun 2017 16:13:06 +0200

ffindex (0.9.9.7-3) unstable; urgency=medium

  * Fix autopkgtest

 -- Andreas Tille <tille@debian.org>  Sun, 15 Jan 2017 10:37:05 +0100

ffindex (0.9.9.7-2) unstable; urgency=medium

  * Team upload.
  [ Canberk Koç ]
  * Autopkgtest suite added.

  [ Andreas Tille ]
  * Moved packaging from SVN to Git
  * Use chrpath to remove rpath since that's a lintian error
  * Remove explicit -dbg package
  * Fix autopkgtest
  * debhelper 10

 -- Andreas Tille <tille@debian.org>  Thu, 29 Dec 2016 23:10:15 +0100

ffindex (0.9.9.7-1) unstable; urgency=medium

  * New upstream version
  * cme fix dpkg-control
  * enable mpi

 -- Andreas Tille <tille@debian.org>  Sun, 08 May 2016 00:43:21 +0200

=== debian/control ===
--- 
+++ 
@@ -4,13 +4,14 @@
            Andreas Tille <tille@debian.org>
 Section: science
 Priority: optional
-Build-Depends: debhelper (>= 9),
+Build-Depends: debhelper (>= 10),
                help2man,
-#               libopenmpi-dev,
-#               openmpi-bin  ... needs another Build-Depends to create the manpage - but which one?
-Standards-Version: 3.9.6
-Vcs-Browser: http://anonscm.debian.org/viewvc/debian-med/trunk/packages/ffindex/trunk/
-Vcs-Svn: svn://anonscm.debian.org/debian-med/trunk/packages/ffindex/trunk/
+               libopenmpi-dev,
+               openmpi-bin,
+               chrpath
+Standards-Version: 4.0.0
+Vcs-Browser: https://anonscm.debian.org/git/debian-med/ffindex.git
+Vcs-Git: https://anonscm.debian.org/git/debian-med/ffindex.git
 Homepage: http://www.splashground.de/~andy/programs/FFindex/
 
 Package: ffindex
@@ -56,19 +57,3 @@
  .
  This package contains the header files and documentation needed to develop
  applications with libffindex.
-
-Package: ffindex-dbg
-Architecture: any
-Section: debug
-Priority: extra
-Depends: ffindex (= ${binary:Version}),
-         libffindex0 (= ${binary:Version}),
-         ${misc:Depends}
-Description: simple index/database for huge amounts of small files (debug)
- FFindex is a very simple index/database for huge amounts of small files. The
- files are stored concatenated in one big data file, separated by '\0'. A
- second file contains a plain text index, giving name, offset and length of
- the small files. The lookup is currently done with a binary search on an
- array made from the index file.
- .
- This package provides the detached debug symbols for ffindex and libffindex.

=== debian/rules ===
--- 
+++ 
@@ -6,13 +6,18 @@
 # lkajan: work in progress, enable this in next upstream release, after speaking to upstream
 # tille@d.o: If enabled only ffindex_apply_mpi and for creating the manpage another (not yet
 #            known) Build-Depends is needed.
-# export HAVE_MPI:=1
+
+pkgdata:=ffindex
+sampledir:=$(CURDIR)/debian/$(pkgdata)/usr/share/doc/$(pkgdata)/examples
+
+export HAVE_MPI:=1
+
+export DEB_BUILD_MAINT_OPTIONS = hardening=+all
 
 %:
-	dh $@ --parallel
+	dh $@
 
-FFMANPAGES = ffindex_apply.1 ffindex_build.1 ffindex_from_fasta.1 ffindex_get.1 ffindex_modify.1 ffindex_unpack.1
-# ffindex_apply_mpi.1
+FFMANPAGES = ffindex_apply.1 ffindex_build.1 ffindex_from_fasta.1 ffindex_get.1 ffindex_modify.1 ffindex_unpack.1 ffindex_apply_mpi.1 ffindex_from_tsv.1
 ffmanpages: $(FFMANPAGES)
 BINNAMES =	\
 		ffindex_apply="apply a program to each FFindex entry";\
@@ -20,8 +25,9 @@
 		ffindex_from_fasta="populate index from FASTA file";\
 		ffindex_get="retrieve entries from file index";\
 		ffindex_modify="modify file index entries";\
-		ffindex_unpack="unpack file index entries";
-#		ffindex_apply_mpi="apply a program to each FFindex entry (mpi enhanced)";\
+		ffindex_unpack="unpack file index entries";\
+		ffindex_apply_mpi="apply a program to each FFindex entry (mpi enhanced)";\
+		ffindex_from_tsv="populate index from TSV file";
 
 override_dh_installman: $(FFMANPAGES)
 	dh_installman
@@ -33,8 +39,9 @@
 	rm -f $(FFMANPAGES)
 	dh_clean
 
-override_dh_strip:
-	dh_strip --dbg-package=ffindex-dbg
+override_dh_install:
+	dh_install
+	find debian -name ffindex_apply_mpi -exec chrpath --delete \{\} \;
 
 # [Laszlo Kajan <lkajan@rostlab.org>]
 # ffindex has an overly large default for FFINDEX_MAX_INDEX_ENTRIES (40000000). In order to require less RAM for testing the package (make check), a more modest value is set below.
@@ -44,3 +51,9 @@
 get-orig-source:
 	mkdir -p ../tarballs
 	uscan --verbose --force-download --destdir=../tarballs
+
+override_dh_installexamples:
+	dh_installexamples
+	cp -aR test $(sampledir)/;
+	cp ./src/test.should $(sampledir)/;
+	cp ./src/test-unlink.should $(sampledir)/;

## ffindex 0.9.9.9

=== perl5/Makefile ===
test:
	perl test.pl

=== src/CMakeLists.txt ===
set(CMAKE_C_FLAGS "-std=c99 ${CMAKE_C_FLAGS}")

# sets HAVE_FMEMOPEN
add_subdirectory(ext)

add_library (ffindex ffindex.c ffutil.c ffindex_posix_search.c)

target_include_directories (ffindex PUBLIC ${CMAKE_CURRENT_SOURCE_DIR})

add_library (ffindex_shared SHARED ffindex.c ffutil.c)

if(NOT HAVE_FMEMOPEN)
        target_link_libraries(ffindex ext)
        target_link_libraries(ffindex_shared ext)
endif()



add_executable(ffindex_apply
        ffindex_apply_mpi.c
)
target_link_libraries (ffindex_apply ffindex)
set_property(TARGET ffindex_apply PROPERTY COMPILE_FLAGS "-UHAVE_MPI")

find_package(MPI)
if(MPI_C_FOUND AND HAVE_MPI)
    add_executable(ffindex_apply_mpi
      ffindex_apply_mpi.c
    )
    target_link_libraries (ffindex_apply_mpi ffindex)
    add_subdirectory(mpq)

    set_property(TARGET ffindex_apply_mpi PROPERTY COMPILE_FLAGS "-DHAVE_MPI=1 ${MPI_C_COMPILE_FLAGS}")
    set_property(TARGET ffindex_apply_mpi PROPERTY LINK_FLAGS "${MPI_C_LINK_FLAGS}")

    target_include_directories(ffindex_apply_mpi PUBLIC ${MPI_C_INCLUDE_PATH})
    target_link_libraries (ffindex_apply_mpi mpq ${MPI_C_LIBRARIES})
    install(TARGETS
        ffindex_apply_mpi
        DESTINATION bin
    )
endif()


add_executable(ffindex_build
  ffindex_build.c
)
target_link_libraries (ffindex_build ffindex)


add_executable(ffindex_from_fasta
  ffindex_from_fasta.c
)
target_link_libraries (ffindex_from_fasta ffindex)


add_executable(ffindex_get
  ffindex_get.c
)
target_link_libraries (ffindex_get ffindex)


add_executable(ffindex_modify
  ffindex_modify.c
)
target_link_libraries (ffindex_modify ffindex)


add_executable(ffindex_unpack
  ffindex_unpack.c
)
target_link_libraries (ffindex_unpack ffindex)


install(PROGRAMS 
        ffindex.h 
        ffutil.h
        DESTINATION include
)

install(TARGETS ffindex
  LIBRARY DESTINATION lib64 COMPONENT libraries
        ARCHIVE DESTINATION lib64 COMPONENT libraries
)


install(TARGETS ffindex_shared
  LIBRARY DESTINATION lib64 COMPONENT libraries
        ARCHIVE DESTINATION lib64 COMPONENT libraries
)


INSTALL( 
  TARGETS
  ffindex_apply
  ffindex_build
  ffindex_from_fasta
  ffindex_get
  ffindex_modify
  ffindex_unpack
  DESTINATION bin
)

=== src/Makefile ===
--- 
+++ 
@@ -86,6 +86,9 @@
 ffindex_unpack: ffindex_unpack.o $(FFINDEX_LIBS)
 	$(CC) -o $@ ffindex_unpack.o $(LDFLAGS) $(STATIC)
 
+ffindex_order: ffindex_order.o $(FFINDEX_LIBS)
+	$(CC) -o $@ ffindex_unpack.o $(LDFLAGS) $(STATIC)
+
 test:
 	rm -f /tmp/test.data /tmp/test.ffindex
 	LD_LIBRARY_PATH=".:$(LD_LIBRARY_PATH)" ./ffindex_build -s /tmp/test.data /tmp/test.ffindex ../test/data ../test/data2

=== src/ext/CMakeLists.txt ===
### fmemopen
include (${CMAKE_ROOT}/Modules/CheckFunctionExists.cmake)
check_function_exists(fmemopen HAVE_FMEMOPEN)

if(NOT HAVE_FMEMOPEN)
set(EXT_SRC

  fmemopen.c
  fmemopen.h
)
add_library(ext ${EXT_SRC})
endif()

=== debian/changelog ===
ffindex (0.9.9.9-6) unstable; urgency=medium

  * Fix watch file
  * Standards-Version: 4.6.1 (routine-update)

 -- Andreas Tille <tille@debian.org>  Thu, 03 Nov 2022 18:10:23 +0100

ffindex (0.9.9.9-5) unstable; urgency=medium

  [ Steffen Moeller ]
  * Fix watchfile to detect new versions on github (routine-update)

  [ Andreas Tille ]
  * Standards-Version: 4.6.0 (routine-update)

 -- Andreas Tille <tille@debian.org>  Fri, 24 Sep 2021 11:43:49 +0200

ffindex (0.9.9.9-4) unstable; urgency=medium

  * Standards-Version: 4.5.1 (routine-update)
  * debhelper-compat 13 (routine-update)
  * autopkgtest: s/ADTTMP/AUTOPKGTEST_TMP/g (routine-update)
  * Add salsa-ci file (routine-update)
  * Rules-Requires-Root: no (routine-update)
  * Trim trailing whitespace.
  * Set upstream metadata fields: Bug-Database, Bug-Submit, Repository,
    Repository-Browse.

 -- Andreas Tille <tille@debian.org>  Sat, 05 Dec 2020 11:52:59 +0100

ffindex (0.9.9.9-3) unstable; urgency=medium

  * Team upload
  * Tweak cross patch to unbreak build, where
    wl,asneeded is default (Closes: #925678).

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Fri, 10 May 2019 08:54:14 +0200

ffindex (0.9.9.9-2) unstable; urgency=medium

  * Team upload.
  * Add patch from helmutg@ to enable cross building; thanks! Closes: #923637.

 -- Michael R. Crusoe <michael.crusoe@gmail.com>  Sun, 03 Mar 2019 13:56:41 -0600

ffindex (0.9.9.9-1) unstable; urgency=medium

  * New upstream version

 -- Andreas Tille <tille@debian.org>  Mon, 28 Jan 2019 19:03:23 +0100

ffindex (0.9.9.8-1) unstable; urgency=medium

  * Revert again to original code which now added the interface for
    hhsuite
    Closes: #907624
  * debhelper 12

 -- Andreas Tille <tille@debian.org>  Fri, 11 Jan 2019 13:40:22 +0100

ffindex (0.9.9.7.soedinglab+git20171201.74550c8-1) unstable; urgency=medium

  * Revert latest change and base packaging again on soedinglab
    (see README.source)
  * Standards-Version: 4.3.0
  * Respect DEB_BUILD_OPTIONS in override_dh_auto_test target

 -- Andreas Tille <tille@debian.org>  Wed, 09 Jan 2019 16:45:16 +0100

ffindex (0.9.9.7+sog+git20160415.14274c9-1) unstable; urgency=medium

  * The previous location on Github was an improperly chosen fork
    (see https://github.com/soedinglab/ffindex_soedinglab/issues/4)
    Here the version is now named "0.9.9.7+sog" (Saved On Github)
    to make it alphabethically later than the previous one.
    Closes: #907624
  * debhelper 11
  * Standards-Version: 4.2.1

 -- Andreas Tille <tille@debian.org>  Fri, 21 Dec 2018 08:39:13 +0100

ffindex (0.9.9.7+soedinglab+git20180802.74550c8-1) unstable; urgency=medium

  * Fix watch file (version should actually be +git20171201.74550c8 but
    its pointless to add an epoch)
  * Fix Vcs-Browser
  * Add DEP3 header
  * Add missing Build-Depends: cmake

 -- Andreas Tille <tille@debian.org>  Thu, 30 Aug 2018 11:55:59 +0200

ffindex (0.9.9.7+soedinglab+git20180802-1) unstable; urgency=medium

  * Team upload.

  * New upstream source to help compile hhsuite 3
  * Removed 'get-orig-source' debian/rules target
  * Introduction of 'basename' does not apply and should go through
    upstream - skipped
  * Removed any notion of _tsv binary that do not seem
    available upstream.

 -- Steffen moeller <moeller@debian.org>  Thu, 02 Aug 2018 18:45:59 +0200

=== debian/control ===
--- 
+++ 
@@ -4,15 +4,18 @@
            Andreas Tille <tille@debian.org>
 Section: science
 Priority: optional
-Build-Depends: debhelper (>= 10),
+Build-Depends: debhelper-compat (= 13),
                help2man,
                libopenmpi-dev,
                openmpi-bin,
-               chrpath
-Standards-Version: 4.0.0
-Vcs-Browser: https://anonscm.debian.org/git/debian-med/ffindex.git
-Vcs-Git: https://anonscm.debian.org/git/debian-med/ffindex.git
-Homepage: http://www.splashground.de/~andy/programs/FFindex/
+               cmake,
+               chrpath,
+               pkg-config
+Standards-Version: 4.6.1
+Vcs-Browser: https://salsa.debian.org/med-team/ffindex
+Vcs-Git: https://salsa.debian.org/med-team/ffindex.git
+Homepage: https://github.com/ahcm/ffindex
+Rules-Requires-Root: no
 
 Package: ffindex
 Architecture: any

=== debian/rules ===
--- 
+++ 
@@ -29,6 +29,10 @@
 		ffindex_apply_mpi="apply a program to each FFindex entry (mpi enhanced)";\
 		ffindex_from_tsv="populate index from TSV file";
 
+# MPI binaries built when openmpi headers+library installed
+FFMANPAGES += ffindex_apply_mpi.1
+BINNAMES   += ffindex_apply_mpi="apply a program to each FFindex entry (mpi enhanced)";
+
 override_dh_installman: $(FFMANPAGES)
 	dh_installman
 
@@ -46,11 +50,9 @@
 # [Laszlo Kajan <lkajan@rostlab.org>]
 # ffindex has an overly large default for FFINDEX_MAX_INDEX_ENTRIES (40000000). In order to require less RAM for testing the package (make check), a more modest value is set below.
 override_dh_auto_test:
+ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
 	dh_auto_test -- FFINDEX_MAX_INDEX_ENTRIES=20000 check
-
-get-orig-source:
-	mkdir -p ../tarballs
-	uscan --verbose --force-download --destdir=../tarballs
+endif
 
 override_dh_installexamples:
 	dh_installexamples

=== debian/watch ===
version=4

opts="filenamemangle=s%(?:.*?)?v?(\d[\d.]*)\.tar\.gz%<project>-$1.tar.gz%" \
https://github.com/ahcm/ffindex/tags .*/v?@ANY_VERSION@@ARCHIVE_EXT@

# This was the original with at some time stalled development
#opts="mode=git,pretty=0.9.9.7+sog+git%cd.%h" \
#    https://github.com/ahcm/ffindex.git HEAD

# This id the fork from soedinglab that causes SIGSEGV
# opts="mode=git,pretty=0.9.9.7.soedinglab+git%cd.%h" \
#    https://github.com/soedinglab/ffindex_soedinglab.git HEAD
